﻿using System;
using System.Collections.Generic;
using System.Text;

namespace LinqStudy
{
    /// <summary>
    /// Person自定义比较器
    /// 各属性均同，则相等.有一个Null值则不相等。
    /// </summary>
    public class PersonEqual : IEqualityComparer<Person>
    {
        bool IEqualityComparer<Person>.Equals(Person x, Person y)
        {
            if (x==null || y==null)
            {
                return false;
            }

            return x.Id == y.Id && x.Name == y.Name && x.Age == y.Age;
        }

        int IEqualityComparer<Person>.GetHashCode(Person obj)
        {
            return (obj.Id+obj.Name+obj.Age).GetHashCode();
        }
    }
}
